%if 0%{?el7}
%define dist .el7
%endif

%{!?_unitdir: %global _unitdir /lib/systemd/system}
%{!?_tmpfilesdir:%global _tmpfilesdir %{_prefix}/lib/tmpfiles.d}
%define user_group  ircd

Name:           ircd-hybrid
Version:        8.2.24
Release:        1%{?dist}
Summary:        A lightweight, high-performance internet relay chat daemon.

Group:          System Environment/Daemons
License:        GPLv2
URL:            http://www.ircd-hybrid.org/
Source0:        http://prdownloads.sourceforge.net/ircd-hybrid/%{name}-%{version}.tgz
Source1:        ircd.service
Source2:        ircd.sysconfig
Source3:        ircd.fedora.conf
Source4:        ircd.logrotate
Source5:        ircd.init
Source6:        ircd-tmpfiles.conf

Patch0:         %{name}-8.2.10-dbpatth.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  openssl-devel, bison, flex
BuildRequires:  GeoIP-devel
BuildRequires:  gcc

Conflicts:      ircd-ratbox

Requires(pre):       shadow-utils
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
Requires(post):      systemd-units
Requires(preun):     systemd-units
Requires(postun):    systemd-units
%else
Requires(post):      /sbin/chkconfig
Requires(preun):     /sbin/chkconfig
Requires(preun):     /sbin/service
Requires(postun):    /sbin/service
%endif

Packager:       momo-i <webmaster@momo-i.org>
Vendor:         momo-i, http://www.momo-i.org/

%description
A lightweight, high-performance internet relay chat daemon.

%package mkpasswd
Summary:    Password hash generator for ircd-hybrid
Group:      Applications/File
Conflicts:  ircd-ratbox-mkpasswd

%description mkpasswd
Ircd-mkpasswd is a password hash generator for ircd-hybrid.

%prep
%setup -q
%patch0 -p1
mv -f tools/README tools/README.tools

%build
%configure \
	--enable-shared \
	--disable-static \
	--sysconfdir=%{_sysconfdir}/ircd \
	--libdir=%{_datadir} \
	--enable-openssl \
	--enable-assert \
	--enable-kqueue \
	--enable-epoll \
	--enable-devpoll \
	--enable-poll \
	--enable-select \
	--enable-halfops

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mv -f $RPM_BUILD_ROOT%{_bindir}/mkpasswd $RPM_BUILD_ROOT%{_bindir}/ircd-mkpasswd
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
install -D -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_unitdir}/ircd.service
install -D -m644 %{SOURCE6} $RPM_BUILD_ROOT%{_tmpfilesdir}/ircd.conf
%else
install -D -m755 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/ircd
%endif
install -D -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ircd
install -D -m644 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/ircd/ircd.conf
install -D -m664 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/ircd

mkdir -p $RPM_BUILD_ROOT%{_var}/log/ircd  $RPM_BUILD_ROOT%{_var}/run/ircd-hybrid
mkdir -p $RPM_BUILD_ROOT%{_var}/lib/ircd-hybrid
mv -f $RPM_BUILD_ROOT%{_sysconfdir}/ircd/reference.conf $RPM_BUILD_ROOT%{_sysconfdir}/ircd/ircd.conf.dist
echo "Internet Relay Chat server" > $RPM_BUILD_ROOT%{_sysconfdir}/ircd/ircd.motd
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mv -f $RPM_BUILD_ROOT%{_bindir}/ircd $RPM_BUILD_ROOT%{_sbindir}/ircd

%pre
getent group ircd  >/dev/null || groupadd -r ircd
getent passwd ircd >/dev/null || \
useradd -r -g ircd -d %{_var}/run/ircd-hybrid -s /sbin/nologin \
    -c "ircd-hybrid user" ircd

%post
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
if [ $1 -eq 1 ] ; then
	# Initial installation
	/bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi
%else
/sbin/chkconfig --add ircd
%endif

%preun
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
if [ $1 -eq 0 ] ; then
	# Package removal, not upgrade
	/bin/systemctl --no-reload disable ircd.service > /dev/null 2>&1 || :
	/bin/systemctl stop ircd.service > /dev/null 2>&1 || :
fi
%else
	/sbin/service ircd stop &>/dev/null || :
	/sbin/chkconfig --del ircd
%endif

%postun
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
	# Package upgrade, not uninstall
	/bin/systemctl try-restart ircd.service >/dev/null 2>&1 || :
fi
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog INSTALL NEWS README doc/*.txt doc/technical
%doc tools/README*
%{!?_licensedir:%global license %%doc}
%license COPYING
%{_sbindir}/ircd
%{_datadir}/ircd-hybrid/*
%{_mandir}/man8/ircd.8*
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%{_unitdir}/ircd.service
%{_tmpfilesdir}/ircd.conf
%else
%{_sysconfdir}/rc.d/init.d/ircd
%endif
%{_sysconfdir}/sysconfig/ircd
%config(noreplace) %{_sysconfdir}/ircd/ircd.motd
%config(noreplace) %{_sysconfdir}/ircd/ircd.conf
%config %{_sysconfdir}/ircd/ircd.conf.dist
%{_sysconfdir}/logrotate.d/ircd
%dir %attr(750,ircd,ircd) %{_var}/log/ircd
%dir %attr(750,ircd,ircd) %{_var}/run/ircd-hybrid
%dir %attr(750,ircd,ircd) %{_sysconfdir}/ircd
%dir %attr(750,ircd,ircd) %{_var}/lib/ircd-hybrid

%files mkpasswd
%doc tools/README.mkpasswd
%{_bindir}/ircd-mkpasswd

%changelog
* Sun Jul 15 2018 momo-i <webmaster@momo-i.org> - 8.2.24-1
- Update to 8.2.24

* Wed Nov 09 2016 momo-i <webmaster@momo-i.org> - 8.2.20-1
- Update to 8.2.20

* Sat Oct 01 2016 momo-i <webmaster@momo-i.org> - 8.2.19-1
- Update to 8.2.19

* Tue May 10 2016 momo-i <webmaster@momo-i.org> - 8.2.17-1
- Update to 8.2.17

* Mon Feb 08 2016 momo-i <webmaster@momo-i.org> - 8.2.13-1
- Update to 8.2.13

* Mon Jan 18 2016 momo-i <webmaster@momo-i.org> - 8.2.12-1
- Update to 8.2.12

* Wed Dec 09 2015 momo-i <webmaster@momo-i.org> - 8.2.11-1
- Update to 8.2.11

* Mon Nov 09 2015 momo-i <webmaster@momo-i.org> - 8.2.10-1
- Update to 8.2.10

* Thu Sep 17 2015 momo-i <webmaster@momo-i.org> - 8.2.9-1
- Update to 8.2.9

* Thu Sep 03 2015 momo-i <webmaster@momo-i.org> - 8.2.8-10
- Update dist for centos7

* Mon Aug 10 2015 momo-i <webmaster@momo-i.org> - 8.2.8-9
- Rebuilt for fc23

* Tue Jun 09 2015 momo-i <webmaster@momo-i.org> - 8.2.8-8
- Update to 8.2.8

* Mon Mar  9 2015 momo-i <webmaster@momo-i.org> - 8.2.5-8
- Update to 8.2.5

* Mon Oct  6 2014 momo-i <webmaster@momo-i.org> - 8.2.0-8
- Update to 8.2.0

* Wed Feb 05 2014 momo-i <webmaster@momo-i.org> - 8.1.13-8
- Update patch 
- Create empty motd

* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-7
- Update systemd file

* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-6
- Add dbpath patch and /var/lib/ircd-hybrid

* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-5
- Fixed dbdir permission?

* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-4
- Add tmpfiles.d

* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-3
- Update spec file

* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-2
- Fixed ircd.conf
- move *.so /usr/lib{64} to /usr/share

* Tue Feb 04 2014 momo-i <webmaster@momo-i.org> - 8.1.13-1
- Initial rpm release
